<template>
	<view class="container login">
		<view class="login-main">
			<text class="logo-text">您的微信尚未绑定供应商账号，填写以下资料进行绑定后，您能通过微信快速登录</text>
		</view>
		<view class="login-form clearfix">
			<view class="login-input">
				<input type="text" 
					   v-model="bindLinkName"  
					   maxlength="30" 
					   class="input" 
					   placeholder="请输入供应商联系人姓名"
				/>
			</view>
		</view>
		<view class="login-form clearfix">
			<view class="login-input">
				<input type="number" 
					   v-model="bindLinkPhone"  
					   maxlength="11" 
					   class="input" 
					   placeholder="请输入手机号"
				/>
			</view>
		</view>
		<view class="login-form clearfix">
			<view class="login-input code">
				<input type="text" 
					   v-model="imageCode"  
					   maxlength="4" 
					   class="input" 
					   placeholder="请输入右侧图形验证码"
				/>
			</view>
			<view class="login-input img-btn">
				<view class="vscodeimg">
					<image :src="imageCodeUrl" mode=""></image>
				</view>
				<view class="vscod-refresh"  @click.stop="getVerificationCode">
					<text class="iconfont icon-shuaxin"></text>
					<text class="ref-text">刷新</text>
				</view>
			</view>
		</view>
		<view class="login-form clearfix">
			<view class="login-input code">
				<input type="number" 
					   v-model="mobildeCode"  
					   maxlength="6" 
					   class="input" 
					   placeholder="请输入短信验证码"
				/>
			</view>
			<view class="login-input btn" :class="[isMobileDisabled  ? 'disabled' : '']" >
				<button type="button"
						@click.stop="getMobileCodeFn"
						:disabled="isMobileDisabled"
					    class="input">
						{{ mobileCodeText }}
				</button>
			</view>
		</view>
		<view class="login-form clearfix">
			<view class="login-btn"  @click="bindWechatInfo">绑定</view>
		</view>
	</view>
</template>

<script>
	import { mapState,mapMutations } from 'vuex'
	import authorize from '@/common/config/authorize.js' 
	import wxLogin from "@/common/config/wxLogin.js"
	export default{
		data() {
			return{
				shopOrderId:0,
				wxUserInfo:{},			//储存用户微信信息
				bindLinkName:'',  		//供应商联系人姓名
				bindLinkPhone:'',  		//用户手机号
				mobildeCode:'',  		//手机验证码
				imageCode:'',			//图形验证码
				imageCodeUrl:'',		//图形验证码地址
				imageCodetoken:'',		//图形校验token
				isMobileDisabled:false, //获取手机短信按钮
				count: '',				//倒计时
				mobileCodeText: '获取验证码',
				codeTime: null,
				bind_supplierInfo:{}
			}
		},
		onLoad(option) {
			console.log(this.shopOrderId);
			this.shopOrderId = option.shopOrderId
			this.bind_supplierInfo = uni.getStorageSync('bind_supplierInfo');
			this.getVerificationCode()
			this.getWxAuthorize()
		},
		methods:{
			...mapMutations(['login','logout','wxLogin']),
			async getWxAuthorize(){
				const wechatCode = await authorize.getCode('weixin');// 根据微信的code获取用户登录状态:1已登录过 -1未登录过
				const getUserInfo = await authorize.getUserInfo('weixin');
				this.UserService.UserLoginAuthApplets({ 
					code:wechatCode,
					encryptedData:getUserInfo.encryptedData,
					iv:getUserInfo.iv ,
				})
				.then(response =>{
					this.login(response.data);
					this.$store.commit('updateStatus',response.data)
					uni.setStorageSync('token',response.data.token)
					uni.setStorageSync('unionId',response.data.unionId)
					setTimeout(()=>{
						if(response.data.userIdentity === 1){
							this.$api.navigateTo('/pages/seller/index/index')
						}else if(response.data.userIdentity === 2 || response.data.userIdentity === 4){
							this.$api.switchTabTo('/pages/tabBar/user/user')
						}else if(response.data.userIdentity === 3){
							this.$api.navigateTo('/pages/supplier/index/index')
						}else{
							this.isUserInfo= true
						}
					},1000)
				})
				.catch(error =>{
					this.logout()
					uni.setStorageSync('unionId',error.data.unionId)
					this.$store.commit('updateStatus',error.data)
					this.isUserInfo = true
				})
			},	
			bindWechatInfo(){
				if( this.bindLinkName == ''){
					this.$util.msg('请输入姓名',2000)
					return
				}
				if( this.bindLinkPhone == ''){
					this.$util.msg('请输入手机号',2000)
					return
				}
				if(!this.$reg.isMobile(this.bindLinkPhone)){
					this.$util.msg('请输入正确的手机号',2000)
					return
				}
				if( this.mobildeCode == ''){
					this.$util.msg('请输入手机验证码',2000)
					return
				}
				if(!this.$reg.isMobileCode(this.mobildeCode)){
					this.$util.msg('验证码格式不正确',2000)
					return
				}
				this.GetUserProfile()
			},
			getVerificationCode(){//图形验证
				this.PublicService.GetImgVerifyCode().then(res => {
					this.imageCodeUrl = res.data.baseImage
					this.imageCodetoken = res.data.token
				})
			},
			getMobileCodeFn(){//获取手机验证码
				if( this.bindLinkPhone == ''){
					this.$util.msg('请输入手机号',2000);
					return
				}
				if(!this.$reg.isMobile(this.bindLinkPhone)){
					this.$util.msg('请输入正确的手机号',2000);
					return
				}
				if( this.imageCode == ''){
					this.$util.msg('请输入图形验证码',2000);
					return
				}
				let params = {
						mobile:this.bindLinkPhone,
						userId:this.bind_supplierInfo.userId,
						platformType:2,
						isCheckCaptcha:0,
						imgCode:this.imageCode,
						token:this.imageCodetoken,
					}
				this.isMobileDisabled = true;
				this.PublicService.GetBindMobileCode(params)
					.then(res =>{
					const TIME_COUNT = 60;
					this.$util.msg('验证短信已发送',2000)
			     	if (!this.codeTime) {
			       		this.count = TIME_COUNT;
						this.isMobileDisabled = true;
			       		this.codeTime = setInterval(() => {
			       			if (this.count > 1 && this.count <= TIME_COUNT) {
			         			this.count--
			         			this.mobileCodeText = this.count +'s重新发送'
			        		} else {
				         		this.isMobileDisabled = false;
				         		clearInterval(this.codeTime)
				         		this.codeTime = null
								this.mobileCodeText = '获取验证码'
			        		}
			       		},1000)
			      	}
				}).catch( error =>{
					this.$util.msg(error.msg,2000)
					this.isMobileDisabled = false;
				})
			},
			GetUserProfile(){//获取用户微信个人信息
				const self = this
				wx.getUserProfile({
					desc: '采美采购商城小程序获取您的信息', // 声明获取用户个人信息后的用途，后续会展示在弹窗中，请谨慎填写
					success(res) {
						console.log('微信获取用户信息新API',res)	
						self.wxLogin(res.userInfo)	
						self.wxUserInfo.nickName = res.userInfo.nickName
						self.wxUserInfo.avatarUrl = res.userInfo.avatarUrl
						self.BindingWechat()
					},
					fail() {
						self.$util.msg('授权失败', 2000)
					}
				})
			},
			BindingWechat(){//绑定微信并登录
				let params ={
						userId:this.bind_supplierInfo.userId,
						mobile:this.bindLinkPhone,
						linkName:this.bindLinkName,
						smsCode:this.mobildeCode,
						unionId:uni.getStorageSync('unionId'),
						nickName:this.wxUserInfo.nickName,
						avatarUrl:this.wxUserInfo.avatarUrl,
				}
				this.UserService.BindingWechat(params).then(response =>{
					this.login(response.data)
					this.$api.navigateTo(`/pages/supplier/order/order-details?shopOrderId=${this.shopOrderId}`)
				}).catch(error =>{
					this.$util.msg(error.msg,2000)
					this.isUserInfo = true
				})	
			},
			//关闭未授权用户授权提示弹窗
			hideModel(){
				this.isUserInfo = false;
			}
		},
		onShow() {
			
		}
	}
</script>

<style lang="scss">
	.login{
		width: 100%;
		height: auto;
		border-top: 1px solid #F7F7F7;
		.model-warp.none{
			display: none;			
		}
		.model-warp.show{
			display: block;
		}
		.login-main{
			width: 702rpx;
			background: rgba(225, 86, 22, 0.1);
			display: flex;
			flex-direction: column;
			align-items: center;
			height: 68rpx;
			padding: 20rpx 24rpx;
			margin: 24rpx 0 118rpx 0;
			.logo-text{
				font-size: 24rpx;
				line-height: 34rpx;
				color: $color-system;
			}
		}
		.login-form{
			width: 702rpx;
			height: auto;
			padding: 0 24rpx;
			.login-input{
				width: 654rpx;
				height: 40rpx;
				padding: 24rpx;
				margin-bottom: 20rpx;
				background: #F7F7F7;
				border-radius: 50rpx;
				display: flex;
				flex-direction: column;
				align-items: center;
				&.code{
					width: 370rpx;
					float: left;
					margin-right: 20rpx;
				}
				&.btn{
					width: 258rpx;
					height: 88rpx;
					padding: 0;
					float: left;
					background: $btn-confirm;
					.input{
						width: 258rpx;
						height: 88rpx;
						line-height: 88rpx;
						padding: 0;
						border-radius: 50rpx;
						color: #FFFFFF;
						background: $btn-confirm;
					}
					&.disabled{
						background: #F7F7F7;
						.input{
							background: #F7F7F7;
							color: #999999;
						}
					}
				}
				&.img-btn{
					width: 250rpx;
					height: 88rpx;
					padding: 0;
					float: left;
					background: #FFFFFF;
					display: block;
					.vscodeimg{
						width: 180rpx;
						height: 88rpx;
						float: left;
						display: flex;
						flex-direction: column;
						align-items: center;
						border-radius: 10rpx;
						image{
							width: 180rpx;
							height: 88rpx;
							border-radius: 10rpx;
						}
					}
					.vscod-refresh{
						width: 70rpx;
						float: right;
						display: flex;
						flex-direction: column;
						align-items: center;
						.icon-shuaxin{
							font-size: 48rpx;
							color: #333333;
						}
						.ref-text{
							font-size: 24rpx;
							color: #333333;
						}
					}
				}
				.input{
					width: 100%;
					height: 100%;
					background: #F7F7F7;
					font-size: $font-size-28;
					line-height: 40rpx;
					color: #333333;
					border-radius: 14rpx;
				}
			}
		}
		.login-btn{
			width: 702rpx;
			height: 88rpx;
			border-radius: 50rpx;
			font-size: $font-size-28;
			line-height: 88rpx;
			color: #FFFFFF;
			margin: 0 auto;
			text-align: center;
			background: $btn-confirm;
			margin-top: 100rpx;
		}
		.model-authorization{
			width: 100%;
			height: 100%;
			position: fixed;
			top: 0;
			left: 0;
			z-index: 999;
			.authorization{
				width: 518rpx;
				height: 320rpx;
				position: absolute;
				background: rgba(255,255,255,.7);
				left: 0;
				right: 0;
				bottom: 0;
				top: 0;
				margin: auto;
				.to-btn{
					position: absolute;
					top: 0;
					left: 0;
					right: 0;
					bottom: 0;
					margin: auto;
					width: 70%;
					height: 88rpx;
					font-size: $font-size-28;
					line-height: 88rpx;
					color: #FFFFFF;
					text-align: center;
					border-radius: 44rpx;
				}
			}
		}
	}
</style>
